#include "BinFile.h"
#include "File.h"

int main() {
    date_time dt;
    bool del_sign;
    std::string buff;
    std::vector<File> res;
    std::string fname;
    bool flag = 0;
    int key;
    std::cout << "Enter the filename" << std::endl;
    std::cin >> fname;
    BinFile bin_file(fname);
    while (!flag) {
        std::cout << "\nSelect an action:" << std::endl
            << "1. Add the note to file" << std::endl
            << "2. Delete the note from file" << std::endl
            << "3. Replace the note in file" << std::endl
            << "4. Convert the binary file into a text file" << std::endl
            << "5. Search by catalog" << std::endl
            << "6. Search by date" << std::endl
            << "7. Search by deletion sign" << std::endl
            << "8. Exit" << std::endl;
        std::cin >> key;
        system("cls");
        switch (key) {
        case(1):
            bin_file.add_note();
            break;
        case(2):
            bin_file.delete_note();
            break;
        case(3):
            bin_file.replace_note();
            break;
        case(4):
            bin_file.bin_to_txt();
            break;
        case(5):
            std::cout << "Enter the catalog" << std::endl;
            std::cin >> buff;
            res = bin_file.search_by_catalog(buff);
            if (res.empty())
                std::cout << "Catalog not found\n";
            else
                for (size_t i = 0; i < res.size(); i++) {
                    std::cout << res[i];
                }
            res.clear();
            break;
        case(6):
            std::cout << "Enter the date (Example: 2022-01-09/15:01)" << std::endl;
            std::cin >> buff;
            buff += "/01:01";
            dt.fromString(buff);
            res = bin_file.search_by_date(dt);
            if (res.empty())
                std::cout << "Date not found\n";
            else
                for (size_t i = 0; i < res.size(); i++) {
                    std::cout << res[i] << std::endl;
                }
            res.clear();
            break;
        case(7):
            std::cout << "Enter the deletion sign" << std::endl;
            std::cin >> del_sign;
            res = bin_file.search_by_del_sign(del_sign);
            if (res.empty())
                std::cout << "Not found\n";
            else
                for (size_t i = 0; i < res.size(); i++) {
                    std::cout << res[i];
                }
            res.clear();
            break;
        case(8):
            flag = 1;
            break;
        default:
            std::cout << "Try again" << std::endl;
        }
    }
}