#include <iostream>
#include <iomanip>
#include <vector>
#include <list>
#include <deque>
#include "Functions.h"

int main() {
	std::string fname;
	int key;
	bool flag = 0;

	std::vector<double> vector;
	std::list<double> list;
	std::deque<double> deque;

	while (!flag) {
		std::cout << "Input the filename\n";
		std::cin >> fname;
		system("cls");
		std::cout << "Step 1: Creation\n" << "Choose the method:\n";
		std::cout << "1. Using iostreams\n";
		std::cout << "2. Using algorithm generate\n";
		std::cout << "3. File is already created, next step\n";

		std::cin >> key;
		switch (key) {
		case(1):
			createData_v1(fname);
			break;
		case(2):
			std::cout << "Choose the container:\n";
			std::cout << "1. Vector\n";
			std::cout << "2. List\n";
			std::cout << "3. Deque\n";
			std::cout << "Another answer - container vector, next step\n";
			std::cin >> key;
			switch (key) {
			case(1):
				createData_v2<std::vector<int>>(fname); break;
			case(2):
				createData_v2<std::list<int>>(fname); break;
			case(3):
				createData_v2<std::deque<int>>(fname); break;
			default:
				createData_v2<std::vector<int>>(fname);
			}
			break;
		case(3):
			break;
		}

		std::cout << "\nChoose the container to work with:\n";
		std::cout << "1. Vector\n";
		std::cout << "2. List\n";
		std::cout << "3. Deque\n";
		std::cout << "Another answer - container vector, next step\n";

		std::cin >> key;
		switch (key) {
		case(1):
			Application(vector, fname); break;
		case(2):
			Application(list, fname); break;
		case(3):
			Application(deque, fname); break;
		default:
			Application(vector, fname); break;
			break;
		}
		std::cout << "\nDo you want to complete? (0 - No, 1 - Yes)\n";
		std::cin >> flag;
	}
}