#pragma once
#include "File.h"
#include <map>

class BinFile {
    std::string fname;
    std::map<int, File> File_map;
    void make_map(std::map<int, File>&);
public:
    BinFile(const std::string& s) : fname(s) {};
    void add_note();
    void delete_note();
    void replace_note();
    void bin_to_txt();
    std::vector<File> search_by_catalog(const std::string&);
    std::vector<File> search_by_date(date_time);
    std::vector<File> search_by_del_sign(bool);
};


