#pragma once
#include <fstream>
#include <iostream>
#include <string>
#include <iterator>
#include <algorithm>
#include <vector>
#include <stdio.h>
#include <iomanip>
//      : ,  , 
//,    ,   , , 
//,  ,   ( 
//   512 ).   ,  ,
//  .     
//   - .

struct date_time {
	int year;
	int month;
	int day;
	int hour;
	int min;

	explicit date_time() : year(2000), month(1), day(1), hour(1), min(0) {}
	std::string toString();
	date_time& fromString(const std::string& s);
	void print();
};

struct File {
	char catalog[15];
	char fname[15];
	char ext[5];
	date_time dt;
	char attr[20];
	bool del_sign;
	int al_sec;
	friend std::istream& operator>>(std::istream& in, File& f_info);
	friend std::ostream& operator<<(std::ostream& out, File& f_info);

	File() = default;
	File(const File&);
	File& operator=(const File&);
};

